Page MenuHomePhabricator

Editing files and contributing changes via web
Closed, DeclinedPublic

Description

Filed upstream: https://secure.phabricator.com/T6008

A web based code contribution process would lower the barrier for new/casual contributors, as well as technically simple improvements such as source code documentation, HTML/CSS files, and so on. GitHub has this feature and it makes a difference.

Phabricator has Diffusion, which allows you to browse code. How far are we from allowing editing a file via Diffusion, and directly from there create a patch for the related project in Differential?

This use case is real for #Wikimedia, where we have a big community of gadgets, templates, bots, and docs writers used to a wiki interface but not so much (or not at all) to a Git based workflow and its tools. This could be a potential are of focus for us after we are done with our current Maniphest-centric migration.

See also: https://www.mediawiki.org/wiki/Gerrit/Tutorial#Editing_via_the_web-interface

Details

Reference
fl602

Event Timeline

flimport raised the priority of this task from to Normal.
flimport set Reference to fl602.
Qgil lowered the priority of this task from Normal to Lowest.Oct 9 2014, 11:22 PM
Qgil added a subscriber: Qgil.

Similarly to T127: Find way to use Differential with plain git (i.e.: without requiring arc) and T173: GitHub -> Differential bridge for new contributors, we wll focus first in migrating our code review process using the standard Phabricator tools. Alternative ways like the one proposed here should be coordinated upstream first.

According to T65847#1268528 this is something that is supported in gerrit 2.11.

Florian added a subscriber: Florian.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptSep 9 2015, 3:18 PM
greg added a subscriber: greg.Sep 9 2015, 3:31 PM

According to T65847#1268528 this is something that is supported in gerrit 2.11.

The current version (as of today) of our Gerrit installation is 2.8.1-4-ga1048ce. Thus, this is not a feature we would lose in a migration to Differential. Thus it is not a blocker for that migration :) Keeping it in the Differential project because I like the idea.

greg set Security to None.

Having that feature in a released version we could upgrade to is something we lose. So technically it would be blocker. :) But for me personally there are more important things in a git hosting / git browsing / code review tool that this.

greg moved this task from To Triage to Backlog on the Differential board.Nov 4 2015, 7:04 PM
Paladox added a subscriber: Paladox.EditedMay 15 2016, 11:17 PM

@greg I think gerrit on wikimedia will be updated to 2.12 soon.

So not sure weather this could be considered for T135327.

@Qgil would it be possible if this task would be considered for T135327 please.

Since moving from gerrit which will be 2.12 and allow on web editing to differential which has limited support such as you have to create the diff your self that's the only think it allows you to upload on the web.

Also with on the web editing it will get a lot more contributors to help with editing since they would be able to create patches on phones and would make it easy for users that want to create quick patches such as a version bump or some other type of small edit.

@Paladox, looking at our Wikimedia discussions and the discussion upstream, it does not look as a clear candidate for T135327.

Is there any way to retrieve information about the current use of the the Gerrit Patch Uploader? Who is using it and what for? In average, are the patches submitted of equivalent quality than those submitted through the officially supported channels?

I don't have a strong opinion on this, but I'd rather make sure we have a use case here that would justify the big effort that upstream says that this would take.

On the other hand, if @valhallasw could create this tool with the Gerrit API, I wonder whether this tool could be ported to the Phabricator API.

Paladox added a comment.EditedMay 16 2016, 10:11 AM

@Qgil differential supports doing what https://tools.wmflabs.org/gerrit-patch-uploader/ does. You can upload diffs and it will create the revision.

https://phabricator.wikimedia.org/differential/diff/create/

Regarding the future of Gerrit Patch Uploader, I asked Valhallasw a while ago and his reply was:

As I understand it, Phabricator has this built-in:
https://phabricator.wikimedia.org/differential/diff/create/#
and it even seems to work:
https://phabricator.wikimedia.org/D205
The only issue is that it skips arc tests, but those are run server-side anyway after the commit is pushed -- so I think this basically is 1-on-1 feature parity with the current patch uploader, in a much more user-friendly jacket.

Qgil updated the task description. (Show Details)Sep 7 2016, 9:25 AM
Qgil added a subscriber: Quiddity.
Restricted Application added a project: Upstream. · View Herald TranscriptSep 7 2016, 9:36 AM
Restricted Application added a subscriber: TerraCodes. · View Herald Transcript

Adding phabricator upstream tag since it was filled upstream.

But I wonder how we can get https://secure.phabricator.com/T6008 moving along? Since we updated gerrit to use the new inline edit, it made things a whole lot easier.

greg added a comment.Sep 7 2016, 5:10 PM

But I wonder how we can get https://secure.phabricator.com/T6008 moving along? Since we updated gerrit to use the new inline edit, it made things a whole lot easier.

https://secure.phabricator.com/T6008#74784

tl;dr: It'd be really expensive to prioritize and it's not a high priority for upstream right now as other features would get higher use.

TerraCodes added a comment.EditedAug 13 2017, 12:19 AM

Would something like https://orionhub.org/mixloginstatic/landing.html or https://eclipse.org/che/ work? Also I noticed that Phab supports plugins, so couldn't we make a code editor plugin like https://www.mediawiki.org/wiki/Extension:CodeEditor ?

mmodell closed this task as Declined.Oct 31 2018, 7:37 PM